<script lang="ts">
  import Columns from 'components/Columns';
  import CreateIssueButton from 'components/CreateIssueButton';
  import MainLayout from 'layouts/MainLayout';
  import { onDestroy } from 'svelte';
  import { useParams } from 'svelte-navigator';
  import {
    firstIssueCreated,
    kanbanId,
    kanbanShortId,
    kanbans,
  } from 'stores/authStore';
  import {
    isEmptyKanban,
    issues,
  } from 'stores/kanbanStore';
  import {
    operationStore,
    query,
  } from '@urql/svelte';
  import {
    IssuesDocument,
    type IssuesQuery,
    type IssuesQueryVariables,
  } from 'generated/graphql';
  import AddCollaboratorButton from 'components/AddCollaboratorButton';

  const params = useParams();

  const issuesQuery = operationStore<IssuesQuery, IssuesQueryVariables>(IssuesDocument, { issuesKanbanId: $kanbanId }, { pause: true, requestPolicy: 'network-only' });
  query(issuesQuery);

  $: $kanbanShortId = $params?.kanbanShortId;
  $: $issues = $issuesQuery.data?.issues || [];
  $: if ($kanbanId && $kanbans) {
    $issuesQuery.context.pause = false;
    $issuesQuery.variables = { issuesKanbanId: $kanbanId };
  }
  
  $: if ($isEmptyKanban && $firstIssueCreated && $kanbanId) {
    issuesQuery.reexecute({ requestPolicy: 'network-only' });
  }

  onDestroy(() => $kanbanShortId = null);
</script>

<MainLayout>
  <div class="h-full w-10/12 mx-auto">
    <div class="flex gap-4 pt-6 items-center">
      <CreateIssueButton />
      <AddCollaboratorButton />
    </div>
    <Columns />
  </div>
</MainLayout>
